/* netGalacticConquest v 1.01b
 * Release date: 26 Jun 2000
 * Copyright 2000 Anatoliy Okhotnikov <cgc@tolik.8k.com>
 *		
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "network.h"
#include "msg.h"

int establish_listening_socket (unsigned short port_number, char peer_ip_address[20])
{
  int sockfd, new_fd;
  int sin_size;
  int BACKLOG = 2;
  struct sockaddr_in my_addr;
  struct sockaddr_in their_addr;

  my_addr.sin_family = AF_INET;
  my_addr.sin_port = htons (port_number);
  my_addr.sin_addr.s_addr = INADDR_ANY;
  bzero (&(my_addr.sin_zero), 8);

 if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    {
       perror ("socket");
       fprintf (stderr,MESS_74);
      exit (1);
    }

 if (bind (sockfd, (struct sockaddr *) &my_addr, sizeof (struct sockaddr)) == -1)
    {
      /* perror ("bind"); */

       printf(MESS_76);
         printf(MESS_77);
        printf (MESS_79);
      printf (MESS_78);
      exit (1);
    }
 if (listen (sockfd, BACKLOG) == -1)
    {
       perror ("listen");
      fprintf (stderr,MESS_79);
      exit (1);
    }

   sin_size = sizeof (struct sockaddr_in);
   if ((new_fd = accept (sockfd, (struct sockaddr *) &their_addr, &sin_size)) == -1)
	{
	  perror ("accept");
	  fprintf (stderr, MESS_80);
	}
   strcpy (peer_ip_address, inet_ntoa(their_addr.sin_addr));

  return(new_fd);
}

int connect_to_socket (char host_ip_number[20],  unsigned short port_number)
{

  int sockfd;
  struct hostent *he;
  struct sockaddr_in their_addr;	/* connector's address information */

  if ((he = gethostbyname (host_ip_number)) == NULL)
      { /* get the host info */
        /* herror ("gethostbyname"); */
       printf(MESS_81);
         printf(MESS_82);
        printf (MESS_83);
      printf (MESS_78);
      exit (1);
      }
       if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)
      {
       /* perror ("socket"); */
        /* printf ("\n  Do you want to try again [y/n] ?: "); */
      }

      their_addr.sin_family = AF_INET;	/* host byte order */
      their_addr.sin_port = htons (port_number);	/* short, network byte order */
      their_addr.sin_addr = *((struct in_addr *)he->h_addr);
      bzero (&(their_addr.sin_zero), 8);	/* zero the rest of the struct */

      if (connect (sockfd, (struct sockaddr *) &their_addr,sizeof (struct sockaddr)) == -1)
      {
        printf (MESS_84, host_ip_number);
        exit (1);
      }

   return (sockfd);
 }


int read_from_socket ( int connected_socket, char *buffer, int bytes )
{
  int bytescount;
  int bytesread;

  bytescount = 0;
  bytesread  = 0;

  while (bytescount < bytes) {
    if ((bytesread = read(connected_socket, buffer, bytes-bytescount)) > 0) {
      bytescount += bytesread;
      buffer += bytesread;
    }
    else if (bytesread < 0)
      return(-1);
  }
  return( bytescount );
}

int write_to_socket ( int connected_socket, char *buffer, int bytes )
{
  int bytescount;
  int byteswrote;

  bytescount = 0;
  byteswrote  = 0;

  while (bytescount < bytes) {
    if ((byteswrote = write(connected_socket, buffer, bytes-bytescount)) > 0) {
      bytescount += byteswrote;
      buffer += byteswrote;
       }
    else if (byteswrote < 0)
      return(-1);
  }
  return( bytescount );
}
